gtkmm: Gdk::Device Class Reference

gtkmm 3.16.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gdk::Device Class Reference

A Gdk::Device instance contains a detailed description of an extended input device. More...

`#include <gdkmm/device.h>`

Inheritance diagram for Gdk::Device:
[legend]

## Public Member Functions
virtual | ~Device ()
GdkDevice* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkDevice* | gobj () const
| Provides access to the underlying C GObject. More...
GdkDevice* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_name () const
| Determines the name of the device. More...
bool | get_has_cursor () const
| Determines whether the pointer follows device motion. More...
InputSource | get_source () const
| Determines the type of the device. More...
InputMode | get_mode () const
| Determines the mode of the device. More...
bool | set_mode (InputMode mode)
| Sets a the mode of an input device. More...
int | get_n_keys () const
| Returns the number of keys the device currently has. More...
bool | get_key (guint index_, guint& keyval, ModifierType& modifiers) const
| If index has a valid keyval, this function will return `true` and fill in keyval and modifiers with the keyval settings. More...
void | set_key (guint index_, guint keyval, ModifierType modifiers)
| Specifies the X key event to generate when a macro button of a device is pressed. More...
AxisUse | get_axis_use (guint index_) const
| Returns the axis use for index. More...
void | set_axis_use (guint index_, AxisUse use)
| Specifies how an axis of a device is used. More...
void | get_state (const Glib::RefPtr< Window >& window, double& axes, ModifierType& mask)
| Gets the current state of a pointer device relative to window. More...
std::vector< TimeCoord > | get_history (const Glib::RefPtr< Window >& window, guint32 start, guint32 stop) const
| Obtains the motion history for a device. More...
std::vector< Glib::RefPtr< Gdk::Device > > | list_slave_devices ()
| If the device if of type Gdk::DEVICE_TYPE_MASTER, it will return the list of slave devices attached to it, otherwise it will return `0` More...
int | get_n_axes () const
| Returns the number of axes the device currently has. More...
std::vector< std::string > | list_axes () const
| Returns the labels for the axes that the device currently has. More...
bool | get_axis_value (double& axes, GdkAtom axis_label, double& value) const
| Interprets an array of double as axis values for a given device, and locates the value in the array for a given axis label, as returned by list_axes() More...
bool | get_axis (double& axes, AxisUse use, double& value) const
| Interprets an array of double as axis values for a given device, and locates the value in the array for a given axis use. More...
Glib::RefPtr< Display > | get_display ()
| Returns the Gdk::Display to which device pertains. More...
Glib::RefPtr< const Display > | get_display () const
| Returns the Gdk::Display to which device pertains. More...
Glib::RefPtr< Device > | get_associated_device ()
| Returns the associated device to device, if device is of type Gdk::DEVICE_TYPE_MASTER, it will return the paired pointer or keyboard. More...
Glib::RefPtr< const Device > | get_associated_device () const
| Returns the associated device to device, if device is of type Gdk::DEVICE_TYPE_MASTER, it will return the paired pointer or keyboard. More...
DeviceType | get_device_type () const
| Returns the device type for device. More...
GrabStatus | grab (const Glib::RefPtr< Window >& window, GrabOwnership grab_ownership, bool owner_events, EventMask event_mask, const Glib::RefPtr< Cursor >& cursor, guint32 time_)
| Grabs the device so that all events coming from this device are passed to this application until the device is ungrabbed with ungrab(), or the window becomes unviewable. More...
GrabStatus | grab (const Glib::RefPtr< Window >& window, GrabOwnership grab_ownership, bool owner_events, EventMask event_mask, guint32 time_)
| See the grab() method which takes more parameters. More...
void | ungrab (guint32 time_)
| Release any grab on device. More...
void | warp (const Glib::RefPtr< Screen >& screen, int x, int y)
| Warps device in display to the point x, y on the screen screen, unless the device is confined to a window by a grab, in which case it will be moved as far as allowed by the grab. More...
void | get_position (int& x, int& y) const
| Gets the current location of the device. More...
void | get_position (Glib::RefPtr< Screen >& screen, int& x, int& y) const
| Gets the current location of device. More...
void | get_position (double& x, double& y) const
| Gets the current location of the device in double precision. More...
void | get_position (Glib::RefPtr< Screen >& screen, double& x, double& y) const
| Gets the current location of the device in double precision. More...
Glib::RefPtr< Window > | get_window_at_position (int& win_x, int& win_y)
| Obtains the window underneath device, returning the location of the device in win_x and win_y. More...
Glib::RefPtr< const Window > | get_window_at_position (int& win_x, int& win_y) const
| Obtains the window underneath device, returning the location of the device in win_x and win_y. More...
Glib::RefPtr< Window > | get_window_at_position ()
| Obtains the window underneath the device. More...
Glib::RefPtr< const Window > | get_window_at_position () const
| Obtains the window underneath the device. More...
Glib::RefPtr< Window > | get_last_event_window ()
| Gets information about which window the given pointer device is in, based on events that have been received so far from the display server. More...
Glib::RefPtr< const Window > | get_last_event_window () const
| Gets information about which window the given pointer device is in, based on events that have been received so far from the display server. More...
Glib::ustring | get_vendor_id () const
| Returns the vendor ID of this device, or `0` if this information couldn't be obtained. More...
Glib::ustring | get_product_id ()
| Returns the product ID of this device, or `0` if this information couldn't be obtained. More...
Public Member Functions inherited from Glib::Object
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Device ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
virtual | ~ObjectBase ()=0
void | initialize (GObject *castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::Device > | wrap (GdkDevice* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify) (gpointer data)

## Detailed Description

A Gdk::Device instance contains a detailed description of an extended input device.

## Constructor & Destructor Documentation

virtual Gdk::Device::~Device | ( |  | ) |
| virtual

Gdk::Device::Device | ( |  | ) |
| protected

## Member Function Documentation

Glib::RefPtr<Device> Gdk::Device::get_associated_device | ( |  | ) |

Returns the associated device to device, if device is of type Gdk::DEVICE_TYPE_MASTER, it will return the paired pointer or keyboard.

If device is of type Gdk::DEVICE_TYPE_SLAVE, it will return the master device to which device is attached to.

If device is of type Gdk::DEVICE_TYPE_FLOATING, `0` will be returned, as there is no associated device.

Since gtkmm 3.0:

Returns
  The associated device, or `0`.

Glib::RefPtr<const Device> Gdk::Device::get_associated_device | ( |  | ) | const

Returns the associated device to device, if device is of type Gdk::DEVICE_TYPE_MASTER, it will return the paired pointer or keyboard.

If device is of type Gdk::DEVICE_TYPE_SLAVE, it will return the master device to which device is attached to.

If device is of type Gdk::DEVICE_TYPE_FLOATING, `0` will be returned, as there is no associated device.

Since gtkmm 3.0:

Returns
  The associated device, or `0`.

bool Gdk::Device::get_axis | ( | double & | axes,
|  | AxisUse | use,
|  | double & | value
| ) |  | const

Interprets an array of double as axis values for a given device, and locates the value in the array for a given axis use.

Parameters

  axes | Pointer to an array of axes.
  use | The use to look for.
  value | Location to store the found value.

Returns
  `true` if the given axis use was found, otherwise `false`.

AxisUse Gdk::Device::get_axis_use | ( | guint | index_ | ) | const

Returns the axis use for index.

Since gtkmm 2.20:

Parameters

  index | The index of the axis.

Returns
  A Gdk::AxisUse specifying how the axis is used.

bool Gdk::Device::get_axis_value | ( | double & | axes,
|  | GdkAtom | axis_label,
|  | double & | value
| ) |  | const

Interprets an array of double as axis values for a given device, and locates the value in the array for a given axis label, as returned by list_axes()

Since gtkmm 3.0:

Parameters

  axes | Pointer to an array of axes.
  axis_label | Gdk::Atom with the axis label.
  value | Location to store the found value.

Returns
  `true` if the given axis use was found, otherwise `false`.

DeviceType Gdk::Device::get_device_type | ( |  | ) | const

Returns the device type for device.

Since gtkmm 3.0:

Returns
  The Gdk::DeviceType for device.

Glib::RefPtr<Display> Gdk::Device::get_display | ( |  | ) |

Returns the Gdk::Display to which device pertains.

Since gtkmm 3.0:

Returns
  A Gdk::Display. This memory is owned by GTK+, and must not be freed or unreffed.

Glib::RefPtr<const Display> Gdk::Device::get_display | ( |  | ) | const

Returns the Gdk::Display to which device pertains.

Since gtkmm 3.0:

Returns
  A Gdk::Display. This memory is owned by GTK+, and must not be freed or unreffed.

bool Gdk::Device::get_has_cursor | ( |  | ) | const

Determines whether the pointer follows device motion.

This is not meaningful for keyboard devices, which don't have a pointer.

Since gtkmm 2.20:

Returns
  `true` if the pointer follows device motion.

std::vector<TimeCoord> Gdk::Device::get_history | ( | const Glib::RefPtr< Window >& | window,
|  | guint32 | start,
|  | guint32 | stop
| ) |  | const

Obtains the motion history for a device.

Given a starting and ending timestamp, this will return all events in the motion history for the device in the given range of time. Some windowing systems do not support motion history, in which case, false will be returned. (This is not distinguishable from the case where motion history is supported and no events were found.)

Parameters

  window | The window with respect to which which the event coordinates will be reported.
  start | Starting timestamp for range of events to return.
  stop | Ending timestamp for the range of events to return.

Returns
  A vector of TimeCoord.

bool Gdk::Device::get_key | ( | guint | index_,
|  | guint & | keyval,
|  | ModifierType& | modifiers
| ) |  | const

If index has a valid keyval, this function will return `true` and fill in keyval and modifiers with the keyval settings.

Since gtkmm 2.20:

Parameters

  index | The index of the macro button to get.
  keyval | Return value for the keyval.
  modifiers | Return value for modifiers.

Returns
  `true` if keyval is set for index.

Glib::RefPtr<Window> Gdk::Device::get_last_event_window | ( |  | ) |

Gets information about which window the given pointer device is in, based on events that have been received so far from the display server.

If another application has a pointer grab, or this application has a grab with owner_events = `false`, `0` may be returned even if the pointer is physically over one of this application's windows.

Since gtkmm 3.12:

Returns
  The last window the device.

Glib::RefPtr<const Window> Gdk::Device::get_last_event_window | ( |  | ) | const

Gets information about which window the given pointer device is in, based on events that have been received so far from the display server.

If another application has a pointer grab, or this application has a grab with owner_events = `false`, `0` may be returned even if the pointer is physically over one of this application's windows.

Since gtkmm 3.12:

Returns
  The last window the device.

InputMode Gdk::Device::get_mode | ( |  | ) | const

Determines the mode of the device.

Since gtkmm 2.20:

Returns
  A Gdk::InputSource.

int Gdk::Device::get_n_axes | ( |  | ) | const

Returns the number of axes the device currently has.

Since gtkmm 3.0:

Returns
  The number of axes.

int Gdk::Device::get_n_keys | ( |  | ) | const

Returns the number of keys the device currently has.

Since gtkmm 2.24:

Returns
  The number of keys.

Glib::ustring Gdk::Device::get_name | ( |  | ) | const

Determines the name of the device.

Since gtkmm 2.20:

Returns
  A name.

void Gdk::Device::get_position | ( | int & | x,
|  | int & | y
| ) |  | const

Gets the current location of the device.

As a slave device coordinates are those of its master pointer, this function may not be called on devices of type GDK_DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Parameters

  x | This will contain the root window X coordinate of the device.
  y | This will contain the root window X coordinate of the device.

void Gdk::Device::get_position | ( | Glib::RefPtr< Screen >& | screen,
|  | int & | x,
|  | int & | y
| ) |  | const

Gets the current location of device.

As a slave device coordinates are those of its master pointer, this function may not be called on devices of type GDK_DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Parameters

  screen | This will contain the screen that the device is on.
  x | This will contain the root window X coordinate of the device.
  y | This will contain the root window X coordinate of the device.

void Gdk::Device::get_position | ( | double & | x,
|  | double & | y
| ) |  | const

Gets the current location of the device in double precision.

As a slave device coordinates are those of its master pointer, this function may not be called on devices of type GDK_DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Parameters

  x | This will contain the root window X coordinate of the device.
  y | This will contain the root window X coordinate of the device.

Since gtkmm 3.10:

void Gdk::Device::get_position | ( | Glib::RefPtr< Screen >& | screen,
|  | double & | x,
|  | double & | y
| ) |  | const

Gets the current location of the device in double precision.

As a slave device coordinates are those of its master pointer, this function may not be called on devices of type GDK_DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Parameters

  screen | This will contain the screen that the device is on.
  x | This will contain the root window X coordinate of the device.
  y | This will contain the root window X coordinate of the device.

Since gtkmm 3.10:

Glib::ustring Gdk::Device::get_product_id | ( |  | ) |

Returns the product ID of this device, or `0` if this information couldn't be obtained.

This ID is retrieved from the device, and is thus constant for it. See get_vendor_id() for more information.

Since gtkmm 3.16:

Returns
  The product ID, or `0`.

InputSource Gdk::Device::get_source | ( |  | ) | const

Determines the type of the device.

Since gtkmm 2.20:

Returns
  A Gdk::InputSource.

void Gdk::Device::get_state | ( | const Glib::RefPtr< Window >& | window,
|  | double & | axes,
|  | ModifierType& | mask
| ) |  |

Gets the current state of a pointer device relative to window.

As a slave device’s coordinates are those of its master pointer, this function may not be called on devices of type Gdk::DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Parameters

  window | A Gdk::Window.
  axes | An array of doubles to store the values of the axes of device in, or `0`.
  mask | Location to store the modifiers, or `0`.

static GType Gdk::Device::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

Glib::ustring Gdk::Device::get_vendor_id | ( |  | ) | const

Returns the vendor ID of this device, or `0` if this information couldn't be obtained.

This ID is retrieved from the device, and is thus constant for it.

This function, together with get_product_id(), can be used to eg. compose Settings paths to store settings for this device.

[C example ellipted]

Since gtkmm 3.16:

Returns
  The vendor ID, or `0`.

Glib::RefPtr<Window> Gdk::Device::get_window_at_position | ( | int & | win_x,
|  | int & | win_y
| ) |  |

Obtains the window underneath device, returning the location of the device in win_x and win_y.

Returns `0` if the window tree under device is not known to GDK (for example, belongs to another application).

As a slave device coordinates are those of its master pointer, This function may not be called on devices of type Gdk::DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them, see grab().

Since gtkmm 3.0:

Parameters

  win_x | Return location for the X coordinate of the device location, relative to the window origin, or `0`.
  win_y | Return location for the Y coordinate of the device location, relative to the window origin, or `0`.

Returns
  The Gdk::Window under the device position, or `0`.

Glib::RefPtr<const Window> Gdk::Device::get_window_at_position | ( | int & | win_x,
|  | int & | win_y
| ) |  | const

Obtains the window underneath device, returning the location of the device in win_x and win_y.

Returns `0` if the window tree under device is not known to GDK (for example, belongs to another application).

As a slave device coordinates are those of its master pointer, This function may not be called on devices of type Gdk::DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them, see grab().

Since gtkmm 3.0:

Parameters

  win_x | Return location for the X coordinate of the device location, relative to the window origin, or `0`.
  win_y | Return location for the Y coordinate of the device location, relative to the window origin, or `0`.

Returns
  The Gdk::Window under the device position, or `0`.

Glib::RefPtr<Window> Gdk::Device::get_window_at_position | ( |  | ) |

Obtains the window underneath the device.

Returns an empty RefPtr if the window tree under the device is not known to GDK (for example, belongs to another application).

As a slave device coordinates are those of its master pointer, This function may not be called on devices of type Gdk::DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Since gtkmm 3.0:

Returns
  The Gdk::Window under the device position.

Glib::RefPtr<const Window> Gdk::Device::get_window_at_position | ( |  | ) | const

Obtains the window underneath the device.

Returns an empty RefPtr if the window tree under the device is not known to GDK (for example, belongs to another application).

As a slave device coordinates are those of its master pointer, This function may not be called on devices of type Gdk::DEVICE_TYPE_SLAVE, unless there is an ongoing grab on them. See grab().

Since gtkmm 3.0:

Returns
  The Gdk::Window under the device position.

GdkDevice* Gdk::Device::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GdkDevice* Gdk::Device::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GdkDevice* Gdk::Device::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

GrabStatus Gdk::Device::grab | ( | const Glib::RefPtr< Window >& | window,
|  | GrabOwnership | grab_ownership,
|  | bool | owner_events,
|  | EventMask | event_mask,
|  | const Glib::RefPtr< Cursor >& | cursor,
|  | guint32 | time_
| ) |  |

Grabs the device so that all events coming from this device are passed to this application until the device is ungrabbed with ungrab(), or the window becomes unviewable.

This overrides any previous grab on the device by this client.

Note that device and window need to be on the same display.

Device grabs are used for operations which need complete control over the given device events (either pointer or keyboard). For example in GTK+ this is used for Drag and Drop operations, popup menus and such.

Note that if the event mask of an X window has selected both button press and button release events, then a button press event will cause an automatic pointer grab until the button is released. X does this automatically since most applications expect to receive button press and release events in pairs. It is equivalent to a pointer grab on the window with owner_events set to `true`.

If you set up anything at the time you take the grab that needs to be cleaned up when the grab ends, you should handle the Gdk::EventGrabBroken events that are emitted when the grab ends unvoluntarily.

Since gtkmm 3.0:

Parameters

  window | The Gdk::Window which will own the grab (the grab window).
  grab_ownership | Specifies the grab ownership.
  owner_events | If `false` then all device events are reported with respect to window and are only reported if selected by event_mask. If `true` then pointer events for this application are reported as normal, but pointer events outside this application are reported with respect to window and only if selected by event_mask. In either mode, unreported events are discarded.
  event_mask | Specifies the event mask, which is used in accordance with owner_events.
  cursor | The cursor to display while the grab is active if the device is a pointer. If this is `0` then the normal cursors are used for window and its descendants, and the cursor for window is used elsewhere.
  time | The timestamp of the event which led to this pointer grab. This usually comes from the Gdk::Event struct, though Gdk::CURRENT_TIME can be used if the time isn’t known.

Returns
  Gdk::GRAB_SUCCESS if the grab was successful.

GrabStatus Gdk::Device::grab | ( | const Glib::RefPtr< Window >& | window,
|  | GrabOwnership | grab_ownership,
|  | bool | owner_events,
|  | EventMask | event_mask,
|  | guint32 | time_
| ) |  |

See the grab() method which takes more parameters.

std::vector<std::string> Gdk::Device::list_axes | ( |  | ) | const

Returns the labels for the axes that the device currently has.

Since gtkmm 3.4:

std::vector<Glib::RefPtr<Gdk::Device> > Gdk::Device::list_slave_devices | ( |  | ) |

If the device if of type Gdk::DEVICE_TYPE_MASTER, it will return the list of slave devices attached to it, otherwise it will return `0`

Returns
  The list of slave devices, or `0`. The list must be freed with Glib::list_free(), the contents of the list are owned by GTK+ and should not be freed.

void Gdk::Device::set_axis_use | ( | guint | index_,
|  | AxisUse | use
| ) |  |

Specifies how an axis of a device is used.

Parameters

  index | The index of the axis.
  use | Specifies how the axis is used.

void Gdk::Device::set_key | ( | guint | index_,
|  | guint | keyval,
|  | ModifierType | modifiers
| ) |  |

Specifies the X key event to generate when a macro button of a device is pressed.

Parameters

  index | The index of the macro button to set.
  keyval | The keyval to generate.
  modifiers | The modifiers to set.

bool Gdk::Device::set_mode | ( | InputMode | mode | ) |

Sets a the mode of an input device.

The mode controls if the device is active and whether the device’s range is mapped to the entire screen or to a single window.

Note
  This is only meaningful for floating devices, master devices (and slaves connected to these) drive the pointer cursor, which is not limited by the input mode.

Parameters

  mode | The input mode.

Returns
  `true` if the mode was successfully changed.

void Gdk::Device::ungrab | ( | guint32 | time_ | ) |

Release any grab on device.

Since gtkmm 3.0:

Parameters

  time | A timestap (e.g. Gdk::CURRENT_TIME).

void Gdk::Device::warp | ( | const Glib::RefPtr< Screen >& | screen,
|  | int | x,
|  | int | y
| ) |  |

Warps device in display to the point x, y on the screen screen, unless the device is confined to a window by a grab, in which case it will be moved as far as allowed by the grab.

Warping the pointer creates events as if the user had moved the mouse instantaneously to the destination.

Note that the pointer should normally be under the control of the user. This function was added to cover some rare use cases like keyboard navigation support for the color picker in the Gtk::ColorSelectionDialog.

Since gtkmm 3.0:

Parameters

  screen | The screen to warp device to.
  x | The X coordinate of the destination.
  y | The Y coordinate of the destination.

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Device > wrap | ( | GdkDevice * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.